%define	origin		sun
%define	major		1.3
%define minor		1
%define build		04
%define version		%{major}.%{minor}.%{build}
%define cvs_version	1_3_1_04
%define release		1jpp
%define name		%{origin}-j2se%{major}
%define	jdklnk		%{_libdir}/%{origin}-jdk%{major}
%define	jrelnk		%{_libdir}/%{origin}-jre%{major}
%define	jdkdir		%{_libdir}/%{name}
%define	jredir		%{jdkdir}/jre
%define jdkbindir	%{jdkdir}/bin
%define jrebindir	%{jredir}/bin
%define fontdir		%{jredir}/lib/fonts
%define priority	33	
%define section		non-free
%define archive_name	j2sdk-%{cvs_version}-linux-i586.bin
%define toplevel_dir	jdk%{major}.%{minor}_%{build}

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	Java Runtime Environment for %{name}	
License:	Sun Binary Code License
URL:		http://java.sun.com/j2se/1.3
Group:		Development/Interpreters
Vendor:		JPackage Project
Distribution:	JPackage
Source0:	%{archive_name}
Source1:	%{name}-mkalias.pl.bz2
Source2:	%{name}-j2se1.4-LucidaTypewriterRegular.ttf.bz2
NoSource:	0
Provides:	j2se = %{version}
Requires:	/usr/sbin/update-alternatives
Conflicts:	kaffe
BuildArch:	i586
BuildRoot:	%{_tmppath}/%{name}-buildroot
Obsoletes:	%{origin}-jre%{major}
Provides:	%{origin}-jre%{major}

%description
This package contains the Java Runtime Environment for %{name}.

%package devel
Summary:	Java Development Kit for %{name}
Group:		Development/Compilers
Provides:	j2se-devel = %{version}
Requires:	/usr/sbin/update-alternatives
Requires:	%{name} = %{version}-%{release}
Obsoletes:	%{origin}-jsdk%{major}
Provides:	%{origin}-jsdk%{major}

%description devel
The JavaTM Development Kit (JDKTM) contains the software and tools that
developers need to compile, debug, and run applets and applications
written using the Java programming language.

%package demo
Summary:	Demonstration files for %{name}
Group:		Development/Interpreters
Requires:	%{name} = %{version}-%{release}

%description demo
This package contains demonstrations files for %{name}

%package plugin
Summary:	Browser plugin files for %{name}
Group:		Internet/WWW/Browsers
Requires:	%{name} = %{version}-%{release}

%description plugin
This package contains browser plugin files for %{name}

%package jdbc
Summary:	JDBC files for %{name}
Group:		Development/Libraries/Java
Requires:	%{name} = %{version}-%{release}
AutoReqProv:	no
Requires:	libodbc.so.1
Requires:	libodbcinst.so.1

%description jdbc
This package contains JDBC files for %{name}

%package fonts
Summary:        TrueType fonts for %{name}
Group:          Text Processing/Fonts
Requires:	%{name} = %{version}-%{release}
Requires:       /usr/bin/ttmkfdir
Requires:	/usr/sbin/chkfontpath
Requires:       /usr/X11R6/bin/mkfontdir

%description fonts
This package contains the TrueType fonts for %{name}.

%prep
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{toplevel_dir}
# crappy archive won't stop us
export MORE=10000
cp %{SOURCE0} $RPM_BUILD_DIR
sh $RPM_BUILD_DIR/%{archive_name} <<EOF
yes
EOF
rm -f $RPM_BUILD_DIR/%{archive_name}
%setup -T -D -n %{toplevel_dir}
# fix perms
chmod -R go=u-w *
chmod -R u+w *
# additional sources
bzcat %{SOURCE1} > mkalias.pl
bzcat %{SOURCE2} > LucidaTypewriterRegular.ttf

%install
# main files
install -d -m 755 $RPM_BUILD_ROOT%{jdkdir}
cp -a bin include include-old lib $RPM_BUILD_ROOT%{jdkdir}
install -d -m 755 $RPM_BUILD_ROOT%{jredir}
cp -a jre/bin jre/lib jre/plugin $RPM_BUILD_ROOT%{jredir}
(cd $RPM_BUILD_ROOT%{_libdir} && ln -s `basename %{jdkdir}` `basename %{jdklnk}`)
(cd $RPM_BUILD_ROOT%{_libdir} && ln -s `basename %{jdkdir}`/jre `basename %{jrelnk}`)
# man pages
install -d -m 755 $RPM_BUILD_ROOT%{_mandir}/man1
for manpage in man/man1/*; do
  install -m 644 $manpage $RPM_BUILD_ROOT%{_mandir}/man1/`basename $manpage .1`-%{name}.1
done
# demo
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -a demo $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -a src.jar $RPM_BUILD_ROOT%{_datadir}/%{name}

# font-handling:
# remove supplied fonts.{dir,scale} in preference of the ones to be dynamically generated -- Rex
rm -f $RPM_BUILD_ROOT%{fontdir}/fonts.{dir,scale}
# patch LucidaTypewriterRegular.ttf from sun-j2se1.4's working version. -- Rex
install -m 644 LucidaTypewriterRegular.ttf $RPM_BUILD_ROOT%{fontdir}/LucidaTypewriterRegular.ttf

# Most of this shamelessly stolen from redhat's kdebase-2.2.2 specfile
find $RPM_BUILD_ROOT%{jredir} -type d | sed 's|'$RPM_BUILD_ROOT'|%dir |' > $RPM_BUILD_DIR/%{name}-all.files
find $RPM_BUILD_ROOT%{jredir} -type f | sed 's|'$RPM_BUILD_ROOT'||'      >> $RPM_BUILD_DIR/%{name}-all.files
find $RPM_BUILD_ROOT%{jredir} -type l | sed 's|'$RPM_BUILD_ROOT'||'      >> $RPM_BUILD_DIR/%{name}-all.files

cat $RPM_BUILD_DIR/%{name}-all.files | grep plugin      | sort > $RPM_BUILD_DIR/%{name}-plugin.files
cat $RPM_BUILD_DIR/%{name}-all.files | grep Jdbc        | sort > $RPM_BUILD_DIR/%{name}-jdbc.files
cat $RPM_BUILD_DIR/%{name}-all.files | grep "lib/fonts" | sort > $RPM_BUILD_DIR/%{name}-fonts.files
cat $RPM_BUILD_DIR/%{name}-all.files | grep -v plugin | grep -v Jdbc | grep -v "lib/fonts" | sort > $RPM_BUILD_DIR/%{name}.files

# font-handling:
# These %ghost'd files are created properly in %post  -- Rex
# We do these after the find, so they are not listed above.
touch $RPM_BUILD_ROOT%{fontdir}/{fonts.{alias,dir,scale},XftCache}
install -m 755 mkalias.pl $RPM_BUILD_ROOT%{jredir}/bin

%clean
rm -rf $RPM_BUILD_ROOT
rm -f $RPM_BUILD_DIR/%{name}*.files

%post
[ -f %{_mandir}/man1/java-%{name}.1.bz2 ] && ext="bz2"
[ -f %{_mandir}/man1/java-%{name}.1.gz ] && ext="gz"
update-alternatives --install %{_bindir}/java java %{jrebindir}/java %{priority} \
--slave %{_bindir}/keytool	keytool		%{jrebindir}/keytool \
--slave %{_bindir}/policytool	policytool	%{jrebindir}/policytool \
--slave %{_bindir}/rmid		rmid		%{jrebindir}/rmid \
--slave %{_bindir}/rmiregistry	rmiregistry	%{jrebindir}/rmiregistry \
--slave %{_bindir}/tnameserv	tnameserv	%{jrebindir}/tnameserv \
--slave %{_mandir}/man1/java.1.$ext		java.1.$ext		%{_mandir}/man1/java-%{name}.1.$ext \
--slave %{_mandir}/man1/keytool.1.$ext		keytool.1.$ext		%{_mandir}/man1/keytool-%{name}.1.$ext \
--slave %{_mandir}/man1/rmid.1.$ext		rmid.1.$ext		%{_mandir}/man1/rmid-%{name}.1.$ext \
--slave %{_mandir}/man1/rmiregistry.1.$ext	rmiregistry.1.$ext	%{_mandir}/man1/rmiregistry-%{name}.1.$ext \
--slave %{_mandir}/man1/tnameserv.1.$ext	tnameserv.1.$ext	%{_mandir}/man1/tnameserv-%{name}.1.$ext

%post devel
[ -f %{_mandir}/man1/javac-%{name}.1.bz2 ] && ext="bz2"
[ -f %{_mandir}/man1/javac-%{name}.1.gz ] && ext="gz"
update-alternatives --install %{_bindir}/javac javac %{jdkbindir}/javac %{priority} \
--slave %{_bindir}/appletviewer	appletviewer 	%{jdkbindir}/appletviewer \
--slave %{_bindir}/extcheck	extcheck 	%{jdkbindir}/extcheck \
--slave %{_bindir}/idlj		idlj		%{jdkbindir}/idlj \
--slave %{_bindir}/jar		jar		%{jdkbindir}/jar \
--slave %{_bindir}/jarsigner	jarsigner	%{jdkbindir}/jarsigner \
--slave %{_bindir}/javadoc	javadoc		%{jdkbindir}/javadoc \
--slave %{_bindir}/javah	javah		%{jdkbindir}/javah \
--slave %{_bindir}/javap	javap		%{jdkbindir}/javap \
--slave %{_bindir}/jdb		jdb		%{jdkbindir}/jdb \
--slave %{_bindir}/native2ascii	native2ascii	%{jdkbindir}/native2ascii \
--slave %{_bindir}/oldjava	oldjava		%{jdkbindir}/oldjava \
--slave %{_bindir}/oldjavac	oldjavac	%{jdkbindir}/oldjavac \
--slave %{_bindir}/oldjdb	oldjdb		%{jdkbindir}/oldjdb \
--slave %{_bindir}/rmic		rmic		%{jdkbindir}/rmic \
--slave %{_bindir}/serialver	serialver	%{jdkbindir}/serialver \
--slave %{_mandir}/man1/appletviewer.1.$ext	appletviewer.1.$ext	%{_mandir}/man1/appletviewer-%{name}.1.$ext \
--slave %{_mandir}/man1/extcheck.1.$ext		extcheck.1.$ext		%{_mandir}/man1/extcheck-%{name}.1.$ext \
--slave %{_mandir}/man1/jar.1.$ext		jar.1.$ext		%{_mandir}/man1/jar-%{name}.1.$ext \
--slave %{_mandir}/man1/jarsigner.1.$ext	jarsigner.1.$ext	%{_mandir}/man1/jarsigner-%{name}.1.$ext \
--slave %{_mandir}/man1/javac.1.$ext		javac.1.$ext		%{_mandir}/man1/javac-%{name}.1.$ext \
--slave %{_mandir}/man1/javadoc.1.$ext		javadoc.1.$ext		%{_mandir}/man1/javadoc-%{name}.1.$ext \
--slave %{_mandir}/man1/javah.1.$ext		javah.1.$ext		%{_mandir}/man1/javah-%{name}.1.$ext \
--slave %{_mandir}/man1/javap.1.$ext		javap.1.$ext		%{_mandir}/man1/javap-%{name}.1.$ext \
--slave %{_mandir}/man1/jdb.1.$ext		jdb.1.$ext		%{_mandir}/man1/jdb-%{name}.1.$ext \
--slave %{_mandir}/man1/native2ascii.1.$ext	native2ascii.1.$ext	%{_mandir}/man1/native2ascii-%{name}.1.$ext \
--slave %{_mandir}/man1/rmic.1.$ext		rmic.1.$ext		%{_mandir}/man1/rmic-%{name}.1.$ext \
--slave %{_mandir}/man1/serialver.1.$ext	serialver.1.$ext	%{_mandir}/man1/serialver-%{name}.1.$ext

%post fonts
cd %{fontdir}
if [ -x /usr/X11R6/bin/mkfontscale ]; then
	mkfontscale > fonts.scale ||:
elif [ -x /usr/bin/ttmkfdir ]; then
	ttmkfdir >fonts.scale   ||:
	# Fixup lame/broken 0-c-0 entries in fonts.scale -- Rex
	perl -pi -e 's@0-c-0@0-p-0@g' fonts.scale
fi
mkfontdir               ||:
%{jredir}/bin/mkalias.pl fonts.scale > fonts.alias ||:
chkfontpath -q -a %{fontdir}          ||:

# trigger for xftcache in case XFree>=4.1.0 is installed after we are
%triggerin fonts -- XFree86 >= 4.1.0
xftcache %{fontdir} ||:

%postun
if [ "$1" = "0" ]; then
	update-alternatives --remove java %{jrebindir}/java
fi

%postun devel
if [ "$1" = "0" ]; then
	update-alternatives --remove javac %{jdkbindir}/javac
fi

%postun fonts
if [ "$1" = "0" ]; then
	rm -f %{fontdir}/encodings.dir
	chkfontpath -q -r %{fontdir} ||:
fi

%files -f ../%{name}.files
%defattr(-,root,root)
%doc jre/CHANGES jre/COPYRIGHT jre/LICENSE jre/README jre/Welcome.html jre/ControlPanel.html
%dir %{jdkdir}
%{jrelnk}
%{_mandir}/man1/java-%{name}.1*
%{_mandir}/man1/keytool-%{name}.1*
%{_mandir}/man1/rmid-%{name}.1*
%{_mandir}/man1/rmiregistry-%{name}.1*
%{_mandir}/man1/tnameserv-%{name}.1*

%files devel
%defattr(-,root,root)
%doc COPYRIGHT LICENSE README README.html
%{jdkdir}/bin
%{jdkdir}/include
%{jdkdir}/include-old
%{jdkdir}/lib
%{jdklnk}
%{_mandir}/man1/appletviewer-%{name}.1*
%{_mandir}/man1/extcheck-%{name}.1*
%{_mandir}/man1/jar-%{name}.1*
%{_mandir}/man1/jarsigner-%{name}.1*
%{_mandir}/man1/javac-%{name}.1*
%{_mandir}/man1/javadoc-%{name}.1*
%{_mandir}/man1/javah-%{name}.1*
%{_mandir}/man1/javap-%{name}.1*
%{_mandir}/man1/jdb-%{name}.1*
%{_mandir}/man1/native2ascii-%{name}.1*
%{_mandir}/man1/rmic-%{name}.1*
%{_mandir}/man1/serialver-%{name}.1*

%files demo
%defattr(-,root,root)
%{_datadir}/%{name}

%files jdbc -f ../%{name}-jdbc.files
%defattr(-,root,root)

%files plugin -f ../%{name}-plugin.files
%defattr(-,root,root)

%files fonts -f ../%{name}-fonts.files
%defattr(-,root,root)
%{jredir}/bin/mkalias.pl
%ghost %{fontdir}/fonts.dir
%ghost %{fontdir}/fonts.scale
%ghost %{fontdir}/fonts.alias
%ghost %{fontdir}/XftCache

%changelog
* Sun Sep 08 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.3.1.04-1jpp 
- upgrades from Rex Dieter <rdieter@unl.edu>:
 - %%postun: do not remove alternatives on upgrades.
 - %%post: fix extchek->extcheck typo.
 - fonts subpkg

* Sat Jun 08 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.3.1.03-2jpp
- upgrades from Rex Dieter <rdieter@unl.edu>:
 - naming: jre -> j2se, jsdk -> j2se-devel
 - plugin, jdbc subpkgs
- spec cleanup
- changed virtual provides to j2se and j2se-devel
- fixed man page alternative setup
- fixed versioning
- used versioned files for jdbc package requires
- group tags again
- provides and obsoletes jre and jsdk

* Sat May 11 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.3.1-4jpp
- 1.3.1.03
- vendor, distribution, group tags

* Fri Apr 05 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.3.1-3jpp 
- non-free section

* Sun Feb 10 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.3.1-2jpp 
- major version is %{major_version}
- name is %{name}
- jre back in %{jredir}
- corrected rmic alternative
- fixed forgotten man pages
- fixed wrong perms

* Wed Feb 06 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.3.1-1jpp 
- first jpp release
